#include<Arduino.h>
#include "pomery_motorov.h"

bool power = false;

Adafruit_MPU6050 mpu;
int angle_odklon = 0;

int ma_loptu = 0;
int center_na_branu = 0;

float diff = 0;
int previous_angle = 0;
int previous_angle_of_ball = -1;
int angle_of_ball = -1;

#define nenaslo_spravny_uhol_n 20
int uhly_doteraz[nenaslo_spravny_uhol_n*32];
int uhly_doteraz_count = 0;
int angle_count = 0;
int wrong_angle_count = 0;

int possible_angle = -1;
int possible_angle_count = 0;
int new_possible_angle = -1;
int new_possible_angle_count = 0;

#define last_angles_len 400
int last_angles[last_angles_len];

int zmeneny_uhol_count = 0;
int gyro_fun_count = 0;
#define gyro_fun_div 50
#define gyro_fun_max 5000

uint8_t IRS[32];
uint8_t NOT_IRS[32];

void setup() {
  Serial.begin(115200);
  Serial8.begin(115200);
  
  if (!mpu.begin()) {
    Serial.println("Failed to find MPU6050 chip");
    while (1) {
      delay(10);
    }
  }
  mpu.setAccelerometerRange(MPU6050_RANGE_8_G);
  mpu.setGyroRange(MPU6050_RANGE_500_DEG);
  mpu.setFilterBandwidth(MPU6050_BAND_21_HZ);
    
  for(int i=0;i<32;i++){
    IRS[i] = 180;
  }

  for(int i=0;i<32;i++){
    NOT_IRS[i] = 0;
  }
  
  pinMode(PWMA, OUTPUT);
  pinMode(PWMB, OUTPUT);
  pinMode(PWMC, OUTPUT);
  pinMode(PWMD, OUTPUT);

  pinMode(KICKER, OUTPUT);
  pinMode(LED_ENABLE, OUTPUT);

  pinMode(ENA, OUTPUT);
  digitalWrite(ENA, 1);
  pinMode(IN1A, OUTPUT);
  pinMode(IN2A, OUTPUT);

  pinMode(ENB, OUTPUT);
  digitalWrite(ENB, 1);
  pinMode(IN1B, OUTPUT);
  pinMode(IN2B, OUTPUT);

  pinMode(ENC, OUTPUT);
  digitalWrite(ENC, 1);
  pinMode(IN1C, OUTPUT);
  pinMode(IN2C, OUTPUT);

  pinMode(END, OUTPUT);
  digitalWrite(END, 1);
  pinMode(IN1D, OUTPUT);
  pinMode(IN2D, OUTPUT); 

  pinMode(LIGHTREADA, INPUT);
  pinMode(LIGHTREADB, INPUT);
  pinMode(IRREADA , INPUT);
  pinMode(IRREADB, INPUT);
  
  pinMode(LIGHTSET0, OUTPUT);
  pinMode(LIGHTSET1, OUTPUT);
  pinMode(LIGHTSET2, OUTPUT);
  pinMode(LIGHTSET3, OUTPUT);

  pinMode(10, INPUT);

  pinMode(INTERUPT_pin, INPUT);

  attachInterrupt(digitalPinToInterrupt(INTERUPT_pin), interupt, CHANGE);

  digitalWrite(LED_BUILTIN, 1);
}

int controlPin[] = {LIGHTSET0, LIGHTSET1, LIGHTSET2, LIGHTSET3};

const int muxChannel[16][4] = {
  {0, 0, 0, 0}, //channel 0
  {1, 0, 0, 0}, //channel 1
  {0, 1, 0, 0}, //channel 2
  {1, 1, 0, 0}, //channel 3
  {0, 0, 1, 0}, //channel 4
  {1, 0, 1, 0}, //channel 5
  {0, 1, 1, 0}, //channel 6
  {1, 1, 1, 0}, //channel 7
  {0, 0, 0, 1}, //channel 8
  {1, 0, 0, 1}, //channel 9
  {0, 1, 0, 1}, //channel 10
  {1, 1, 0, 1}, //channel 11
  {0, 0, 1, 1}, //channel 12
  {1, 0, 1, 1}, //channel 13
  {0, 1, 1, 1}, //channel 14
  {1, 1, 1, 1} //channel 15
};

void loop() {  
//  tsop();

//  mam_loptu_a_chcem_dat_gol();

//  otoc_sa_ked_si_na_ciare();

  
  
  gyro_fun_count+=1;
//  if(gyro_fun_count%gyro_fun_div==0){
//    vyrovnavanie_na_branu();
//  }
//  if(gyro_fun_count%10==0){
//    mam_loptu_a_chcem_dat_gol();
//  }
  if(gyro_fun_count>=gyro_fun_max){
    gyro_fun_count = 0;
  }
  
//  tsop_old();

  movement(0 , 300);
//  vpred();
}

void interupt()
{
  power = !power;
}

void mam_loptu_a_chcem_dat_gol()
{
  int pin_val = digitalRead(10);
  
  int data = 0;
//  String data_str;
  if (Serial8.available() > 0) {
//      data_str = Serial8.readString();
//      Serial.println(data_str);
      data = Serial8.read();
      Serial.println(data);
      data = (int)data-48;
      if(data==1){
        digitalWrite(LED_BUILTIN, 1);
        center_na_branu = 1;
      }
      if(data==2){
        digitalWrite(LED_BUILTIN, 0);
        center_na_branu = 2;
      }
      else{
        center_na_branu = 0;
      }
  }
  
//  if(pin_val==0 && (angle_of_ball>=320 || angle_of_ball<=40)){
//    if(center_na_branu==1){
//      movement(315,300);
//    }
//    if(center_na_branu==2){
//      movement(45,300);
//    }
//    else{
//      movement(0, 300);
//    }
//  }
}

void vyrovnavanie_na_branu()
{
  sensors_event_t a, g, temp;
  mpu.getEvent(&a, &g, &temp);
  int gyro_x = floor(g.gyro.x*100)-7.5;
  angle_odklon += gyro_x;

  if(angle_odklon<-10000){
    angle_odklon = -angle_odklon;
  }
  else if(angle_odklon>10000){
    angle_odklon = -angle_odklon;
  }

  int speed_of_rotation = angle_odklon/60;
  Serial.println(angle_odklon);

  if(angle_odklon>2000){
//    Serial.print("lava cast pohyb");
    rotate_motor('A', speed_of_rotation);
    rotate_motor('B', speed_of_rotation);
    rotate_motor('C', speed_of_rotation);
    rotate_motor('D', speed_of_rotation);
  }
  else if(angle_odklon<-2000){
//    Serial.print("prava cast pohyb");
    rotate_motor('A', speed_of_rotation);
    rotate_motor('B', speed_of_rotation);
    rotate_motor('C', speed_of_rotation);
    rotate_motor('D', speed_of_rotation);
  }
  else{
    rotate_motor('A', 0);
    rotate_motor('B', 0);
    rotate_motor('C', 0);
    rotate_motor('D', 0);
  }

//  Serial.print(angle_odklon);
//  Serial.print(" Rotation X: ");
//  Serial.print(gyro_x);
//  Serial.println(" rad/s");

  Serial.println();
}

void tsop()
{ 
  int tsop_channel_count = 0;
  int channels[32] = {
                      0,0,0,0,0,0,0,0,
                      0,0,0,0,0,0,0,0,
                      0,0,0,0,0,0,0,0,
                      0,0,0,0,0,0,0,0
                     };

  for (uint8_t channel = 0; channel < 16; channel++)
  {
    for (int i = 0; i < 4; i ++) {
      digitalWrite(controlPin[i], muxChannel[channel][i]);
    }

    int read_ = analogRead(IRREADA);

    if(read_<30){
      IRS[channel]+=1;
      if(IRS[channel]>=9){
        channels[tsop_channel_count] = channel;
        tsop_channel_count+=1;
      }
    }
    else{
      NOT_IRS[channel]+=1;
      if(NOT_IRS[channel]>4){
        NOT_IRS[channel] = 0;
        IRS[channel] = 0;
      }
    }

    read_ = analogRead(IRREADB);
    
    if(read_<30){
      IRS[channel+16]+=1;
      if(IRS[channel+16]>=9){
        channels[tsop_channel_count] = channel+16;
        tsop_channel_count+=1;
      }
    }
    else{
      NOT_IRS[channel+16]+=1;
      if(NOT_IRS[channel+16]>4){
        NOT_IRS[channel+16] = 0;
        IRS[channel+16] = 0;
      }
    }
  }

  if(tsop_channel_count>0){
    int angle = 0;
    int diff = 10000;
    
    int is_angle_in_ANGS = 0;

    int najblizsi_angle = 0;
    int najblizsi_angle_diff = 1000;

    if(previous_angle_of_ball==-1 && angle_of_ball==-1){
      previous_angle_of_ball = ANGS[0];
      angle_of_ball = previous_angle_of_ball;
      for(int i=0;i<last_angles_len;i++){
        last_angles[i] = angle_of_ball;
      }
    }    
    
    for(int i=0;i<tsop_channel_count;i++){
      angle = ANGS[channels[i]];

      if(angle==angle_of_ball){
        is_angle_in_ANGS = 1;
      }
    }

    if(is_angle_in_ANGS==0){
      angle_count += 1;
    }

    int najmensi_uhol_doteraz = 1000;
    int najblizsie_k_nule_diff = 1000;
    if(angle_count>=nenaslo_spravny_uhol_n){

      for(int j=0;j<tsop_channel_count;j++){
        angle = ANGS[channels[j]];
        if(abs(angle-angle_of_ball)<najblizsie_k_nule_diff){
          najblizsie_k_nule_diff = abs(angle-angle_of_ball);
          najmensi_uhol_doteraz = angle;
        }
      }
      

      if(wrong_angle_count<=4){
        if(abs(najmensi_uhol_doteraz-angle_of_ball)>=80){
          wrong_angle_count+=1;
          najmensi_uhol_doteraz = angle_of_ball;
        }
      }
      else{
        wrong_angle_count = 0;
        najmensi_uhol_doteraz = angle;
      }

      if(najmensi_uhol_doteraz>=300 || najmensi_uhol_doteraz<=60){
        najmensi_uhol_doteraz = 360;
      }

      angle_of_ball = najmensi_uhol_doteraz;
      previous_angle_of_ball = angle_of_ball;
      angle_count = 0;
      uhly_doteraz_count = 0; 
    }

    for(int i=0;i<last_angles_len-1;i++){
      last_angles[i] = last_angles[i+1];
    }
    last_angles[last_angles_len-1] = angle_of_ball;

    int move_angle = 0;
    for(int i=0;i<last_angles_len;i++){
      move_angle += last_angles[i];
    }
    move_angle /= last_angles_len;

    
//    Serial.print(angle_of_ball); 
//    Serial.print(",");
//    Serial.println(move_angle); 
    
//    movement(angle_of_ball, 300); 
    //move_to_angle(angle_of_ball, 300);
  }
}

void tsop_old()
{
  int tsop_count = 0;
  delay(500);
  Serial.println();
  Serial.println();
  Serial.println();
  for (uint8_t channel = 1; channel <= 32; channel++)
  {
    for (int i = 0; i < 4; i ++) {
      digitalWrite(controlPin[i], muxChannel[channel][i]);
    }
      if(channel>16)
        Serial.print(analogRead(IRREADB));
      else
          Serial.print(analogRead(IRREADA));
      Serial.print(" ");
      Serial.println(channel);
      delay(50);
  }
}

void movement(int smer_ , int rychlost) 
{
  int smer = (smer_ + 90) % 360; //ja viem ze som to mohol prehodit v poli //TODO
  int16_t speeds[4] = {(int16_t)(pomery_pohybou[smer][0]*rychlost), (int16_t)(pomery_pohybou[smer][1]*rychlost), (int16_t)(pomery_pohybou[smer][2]*rychlost), (int16_t)(pomery_pohybou[smer][3]*rychlost)};

  // ROBOT cislo 1
//   if(smer>45 && smer<136){
//    rotate_motor('B', speeds[0]+(int)(abs((float)speeds[0]/4.5f)));
//    rotate_motor('D', speeds[1]+(int)(abs((float)speeds[1]/4.5f)));
//    rotate_motor('C', speeds[2]+(int)(abs((float)speeds[2]/7.0f)));
//    rotate_motor('A', speeds[3]+(int)(abs((float)speeds[3]/7.0f)));
//  }
//
//  // 90 = {0.353552, -0.353554, -0.353552, 0.353554}
//  if(smer>135 && smer<226){
//    rotate_motor('B', speeds[0]-(int)(abs((float)speeds[0]/4.0f)));
//    rotate_motor('D', speeds[1]+(int)(abs((float)speeds[1]/6.0f)));
//    rotate_motor('C', speeds[2]-(int)(abs((float)speeds[2]/9.0f)));
//    rotate_motor('A', speeds[3]-(int)(abs((float)speeds[3]/9.0f)));
//  }
//
//  // 180 = {0.353555, 0.353552, -0.353555, -0.353552}
//  if(smer>225 && smer<316){
//    rotate_motor('B', speeds[0]-(int)(abs((float)speeds[0]/5.0f)));
//    rotate_motor('D', speeds[1]-(int)(abs((float)speeds[1]/10.0f)));
//    rotate_motor('C', speeds[2]-(int)(abs((float)speeds[2]/7.0f)));
//    rotate_motor('A', speeds[3]-(int)(abs((float)speeds[3]/14.0f)));
//  }
//
//  // 270 = { -0.353553, 0.353553, 0.353553, -0.353553}
//  if(smer>315 || smer<46){
//    rotate_motor('B', speeds[0]+(int)(abs((float)speeds[0]/4.0f)));
//    rotate_motor('D', speeds[1]-(int)(abs((float)speeds[1]/6.0f)));
//    rotate_motor('C', speeds[2]+(int)(abs((float)speeds[2]/9.0f)));
//    rotate_motor('A', speeds[3]+(int)(abs((float)speeds[3]/9.0f)));
//  }

  // ROBOT cislo 2

    // 0 + + - - 
   if(smer>45 && smer<136){
    rotate_motor('B', -(speeds[0]+(int)(abs((float)speeds[0]/4.0f))));
    rotate_motor('D', -(speeds[1]+(int)(abs((float)speeds[1]/4.0f))));
    rotate_motor('C', -(speeds[2]+(int)(abs((float)speeds[2]/2.0f))));
    rotate_motor('A', -(speeds[3]+(int)(abs((float)speeds[3]/2.0f))));
  }

  // 90 = {0.353552, -0.353554, -0.353552, 0.353554}
  if(smer>135 && smer<226){
    rotate_motor('B', -(speeds[0]-(int)(abs((float)speeds[0]/4.0f))));
    rotate_motor('D', -(speeds[1]+(int)(abs((float)speeds[1]/6.0f))));
    rotate_motor('C', -(speeds[2]-(int)(abs((float)speeds[2]/9.0f))));
    rotate_motor('A', -(speeds[3]-(int)(abs((float)speeds[3]/9.0f))));
  }

  // 180 = {0.353555, 0.353552, -0.353555, -0.353552}
  if(smer>225 && smer<316){
    rotate_motor('B', -(speeds[0]-(int)(abs((float)speeds[0]/5.0f))));
    rotate_motor('D', -(speeds[1]-(int)(abs((float)speeds[1]/10.0f))));
    rotate_motor('C', -(speeds[2]-(int)(abs((float)speeds[2]/7.0f))));
    rotate_motor('A', -(speeds[3]-(int)(abs((float)speeds[3]/14.0f))));
  }

  // 270 = { -0.353553, 0.353553, 0.353553, -0.353553}
  if(smer>315 || smer<46){
    rotate_motor('B', -(speeds[0]+(int)(abs((float)speeds[0]/4.0f))));
    rotate_motor('D', -(speeds[1]-(int)(abs((float)speeds[1]/6.0f))));
    rotate_motor('C', -(speeds[2]+(int)(abs((float)speeds[2]/9.0f))));
    rotate_motor('A', -(speeds[3]+(int)(abs((float)speeds[3]/9.0f))));
  }
}

void move_to_angle(int angle, int speed_)
{ 
  int angle_to_move = angle;

  // upravit

  
//  if(angle>20 && angle<340){
//    if((angle>20 && angle<75) || (angle>285 && angle<340)){
//      angle_to_move = angle;
//    }
//    else if((angle>75 && angle<120) || (angle>240 && angle<285)){
//      angle_to_move = 180;
//    }
//    else if(angle>120 && angle<150){
//      angle_to_move = 135;
//    }
//    else if(angle>210 && angle<240){
//      angle_to_move = 225;
//    }
//    else if(angle>150 && angle<210){
//      angle_to_move = 90;
//      if(angle-180>0){
//        angle_to_move = 270;
//      }
//    }
//  }
//  else{
//    angle_to_move = 0;
//  }

  movement(angle_to_move, speed_);
}

void move_to_angle_old(int angle, int speed_)
{
  float new_diff;
  int angle_to_move = angle;
  if(angle_to_move>=360){
    angle_to_move-=360;
  }

  if(angle_to_move>20 && angle_to_move<340){
//    new_diff = abs(angle-previous_angle);
//    
//    if(new_diff>1){
//      diff = 200/new_diff;
//    }
//    if(diff>=80){
//      diff = 0;
//    }
    diff = 0;
  
    if(angle_to_move>=90 && angle_to_move<=180){
      angle_to_move += 90-diff;
    }
    else if(angle_to_move>180 && angle_to_move<=270){
      angle_to_move -= 90-diff;
    }
    else if(angle_to_move<90){
      angle_to_move += 90-diff;
    }
    else{
      angle_to_move -= 90-diff;
    }

  }
  else{
    angle_to_move = 0;
  }

  previous_angle = angle;
  movement(angle_to_move, speed_);
}

void otoc_sa_ked_si_na_ciare()
{
  int angle_to_dodge = angle_of_ball;
  for (uint8_t channel = 1; channel <= 32; channel++)
  {
    for (int i = 0; i < 4; i ++) {
      digitalWrite(controlPin[i], muxChannel[channel][i]);
    }

    if(analogRead(LIGHTREADA)<100){
      Serial.println(svetla[channel]);
      angle_to_dodge = angle_of_ball+180;
      if(angle_to_dodge>360){
        angle_to_dodge -= 360;
      }
      movement(angle_to_dodge, 300);
    }
    
    if(analogRead(LIGHTREADB)<100){
      Serial.println(svetla[channel+16]);
      angle_to_dodge = angle_of_ball+180;
      if(angle_to_dodge>360){
        angle_to_dodge -= 360;
      }
      movement(angle_to_dodge, 300);
    }
  }
}

void stoj()
{
    rotate_motor('B', 0);
    rotate_motor('D', 0);
    rotate_motor('C', 0);
    rotate_motor('A', 0);
}

void vpred() {
  // open A = A
  // open B = C
  // open C = D
  // open D = B

  digitalWrite(IN1A, HIGH);
  digitalWrite(IN2A, LOW);
  analogWrite(PWMA, 255);

  digitalWrite(IN1B, HIGH);
  digitalWrite(IN2B, LOW);
  analogWrite(PWMB, 255);

  digitalWrite(IN1C, HIGH);
  digitalWrite(IN2C, LOW);
  analogWrite(PWMC, 255);

  digitalWrite(IN1D, HIGH);
  digitalWrite(IN2D, LOW);
  analogWrite(PWMD, 255);
}

void kick()
{
  digitalWrite(KICKER, 1);
  delay(200);
  digitalWrite(KICKER, 0);
  delay(500);
}

void ledEnable()
{
  //onOf != onOf
  digitalWrite(LED_ENABLE, 1);
}

void swap(int* xp, int* yp)
{
    int temp = *xp;
    *xp = *yp;
    *yp = temp;
}
 
void bubbleSort(int arr[], int n)
{
    int i, j;
    for (i = 0; i < n - 1; i++)
        for (j = 0; j < n - i - 1; j++)
            if (arr[j] > arr[j + 1])
                swap(&arr[j], &arr[j + 1]);
}
